<?php

	class controller_component_question extends component {

		public function action_index() {
			$this->page['title'] = 'Поиск ' . SITE_NAME;
			$this->page['keywords'] = 'Поиск';
			$this->page['description'] = 'Поиск';

			$question_info = $this->model->get_component_info('question');
			$this->data['page_name'] = $question_info['name'];

			$this->model->createTable();	
			if (isset($_POST['deleteMessage'])) {
				$this->model->deleteNote($_POST['deleteMessage']);
			} 			
			if (!empty($_POST['answerArea']) && isset($_POST['sendAnswer'])) {
				$answer = '';
				foreach($_POST['answerArea'] as $textArea) {
					$answer .= $textArea;
				}

				$this->model->createAnswer($_POST['sendAnswer'], $answer);
			} 

			if (isset($_POST['submit'])) {
				
				$errors = array();	
				
				$message = htmlspecialchars($_POST['message']);
				$this->data['messageText'] = $message;

				$captcha = htmlspecialchars($_POST['captcha']);

				if (empty($message)) {
					$this->data['messageError'] = 'Введите ваш вопрос.';
					array_push($errors, $this->data['messageError']);
				}

				if ($captcha != $_SESSION['captcha']) {
					$this->data['captchaError'] = 'Капча введена неверно.';
					array_push($errors, $this->data['captchaError']);
				}	

				if (count($errors) == 0) {
							
					$curDate = date('Y-m-d H:i:s');

					$this->model->insertNote($message, $curDate);

					$this->data['questionSent'] = 'Вопрос был отправлен.';
					$this->data['messageText'] = '';

				}

			}

			$results = $this->model->readNotes();
			$showMessage = array(
				'id' => array(),
				'message' => array(),
				'creationDate' => array()
			);
			foreach ($results as $row) {
				array_push($showMessage['id'], $row['id']);	
				array_push($showMessage['creationDate'], $row['creationDate']);	
				array_push($showMessage['message'], $row['message']);	
			}
			$countArr = count($showMessage['id']); 
			$this->data['countArr'] = $countArr;
			$this->data['num'] = 0;
			$this->data['showMessage'] = $showMessage;

			$answerResult = $this->model->readAnswers();
			$answerArr = array();
			$idArr = array();
			foreach ($answerResult as $aRow) {
				array_push($idArr, $aRow['id_q']);
				array_push($answerArr, $aRow['answer']);
			}
			if (count($idArr)!=0) {
				$combinedArr = array_combine($answerArr, $idArr);
				$this->data['combinedArr'] = $combinedArr;
			}

			$this->page['head'] = $this->add_css_file(SITE_URL . '/modules/components/question/front_end/views/question.css');
			$this->page['html'] = $this->load_view();
			return $this->page;
		}

	}
	
?>